'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.success = exports.failure = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();
/* eslint-disable no-use-before-define */


var _option = require('./option');

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var formatValue = function formatValue(val) {
  if (val instanceof AbstractEither) {
    return val.inspect();
  } else {
    return JSON.stringify(val) || '';
  }
};

var AbstractEither = function () {
  function AbstractEither() {
    _classCallCheck(this, AbstractEither);
  }

  _createClass(AbstractEither, [{
    key: 'map',


    // Concrete
    value: function map(f) {
      return this.isSuccess ? success(f(this.successValue)) : failure(this.failureValue);
    }
  }, {
    key: 'flatMap',
    value: function flatMap(f) {
      return this.isSuccess ? f(this.successValue) : failure(this.failureValue);
    }
  }, {
    key: 'getOrElse',
    value: function getOrElse(def) {
      return this.isSuccess ? this.successValue : def;
    }
  }, {
    key: 'filter',
    value: function filter(p) {
      return this.isSuccess && p(this.successValue) ? (0, _option.some)(success(this.successValue)) : _option.none;
    }
  }, {
    key: 'toOption',
    value: function toOption() {
      return this.isSuccess ? (0, _option.some)(this.successValue) : _option.none;
    }
  }, {
    key: 'equals',
    value: function equals(anything) {
      if (anything instanceof AbstractEither) {
        if (this.isSuccess && anything.isSuccess) {
          return this.successValue === anything.successValue;
        } else if (this.isFailure && anything.isFailure) {
          return this.failureValue === anything.failureValue;
        } else {
          return false;
        }
      } else {
        return false;
      }
    }
  }, {
    key: 'inspect',
    value: function inspect() {
      if (this.isSuccess) {
        return 'success(' + formatValue(this.successValue) + ')';
      } else {
        return 'failure(' + formatValue(this.failureValue) + ')';
      }
    }
  }, {
    key: 'failure',

    // Abstract
    get: function get() {
      return failureProjection(this);
    }
  }, {
    key: 'failureValue',
    get: function get() {
      throw new Error('Unimplemented AbstractEither#failureValue');
    }
  }, {
    key: 'successValue',
    get: function get() {
      throw new Error('Unimplemented AbstractEither#successValue');
    }
  }]);

  return AbstractEither;
}();

var failureProjection = function failureProjection(e) {
  return {
    map: function map(f) {
      return e.isFailure ? failure(f(e.failureValue)) : success(e.successValue);
    },
    flatMap: function flatMap(f) {
      return e.isFailure ? f(e.failureValue) : success(e.successValue);
    },
    getOrElse: function getOrElse(def) {
      return e.isFailure ? e.failureValue : def;
    },
    filter: function filter(p) {
      return e.isFailure && p(e.failureValue) ? (0, _option.some)(failure(e.failureValue)) : _option.none;
    },
    toOption: function toOption() {
      return e.isFailure ? (0, _option.some)(e.failureValue) : _option.none;
    }
  };
};

var _Failure = function (_AbstractEither) {
  _inherits(_Failure, _AbstractEither);

  function _Failure(value) {
    _classCallCheck(this, _Failure);

    var _this = _possibleConstructorReturn(this, (_Failure.__proto__ || Object.getPrototypeOf(_Failure)).call(this));

    _this.isSuccess = false;
    _this.isFailure = true;

    _this.value = value;
    return _this;
  }

  _createClass(_Failure, [{
    key: 'failureValue',
    get: function get() {
      return this.value;
    }
  }, {
    key: 'successValue',
    get: function get() {
      throw new Error('Called Failure.success');
    }
  }]);

  return _Failure;
}(AbstractEither);

var _Success = function (_AbstractEither2) {
  _inherits(_Success, _AbstractEither2);

  function _Success(value) {
    _classCallCheck(this, _Success);

    var _this2 = _possibleConstructorReturn(this, (_Success.__proto__ || Object.getPrototypeOf(_Success)).call(this));

    _this2.isSuccess = true;
    _this2.isFailure = false;

    _this2.value = value;
    return _this2;
  }

  _createClass(_Success, [{
    key: 'failureValue',
    get: function get() {
      throw new Error('Called Success.failure');
    }
  }, {
    key: 'successValue',
    get: function get() {
      return this.value;
    }
  }]);

  return _Success;
}(AbstractEither);

var failure = exports.failure = function failure(value) {
  return new _Failure(value);
};
var success = exports.success = function success(value) {
  return new _Success(value);
};

exports.default = {
  failure: failure,
  success: success
};