'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/* eslint-disable no-use-before-define */

var AbstractOption = function () {
  function AbstractOption() {
    _classCallCheck(this, AbstractOption);
  }

  _createClass(AbstractOption, [{
    key: 'get',

    // Abstract
    value: function get() {
      throw new Error('Unimplemented AbstractOption#get');
    }

    // Concrete

  }, {
    key: 'map',
    value: function map(f) {
      return this.isEmpty ? none : some(f(this.get()));
    }
  }, {
    key: 'flatMap',
    value: function flatMap(f) {
      return this.isEmpty ? none : f(this.get());
    }
  }, {
    key: 'forEach',
    value: function forEach(f) {
      if (this.nonEmpty) {
        f(this.get());
      }
    }
  }, {
    key: 'getOrElse',
    value: function getOrElse(def) {
      return this.isEmpty ? def : this.get();
    }
  }, {
    key: 'getOrElseL',
    value: function getOrElseL(def) {
      return this.isEmpty ? def() : this.get();
    }
  }, {
    key: 'filter',
    value: function filter(p) {
      return this.isEmpty || p(this.get()) ? this : none;
    }
  }, {
    key: 'equals',
    value: function equals(anything) {
      if (anything instanceof AbstractOption) {
        return this.isEmpty ? anything.isEmpty : anything.nonEmpty && this.get() === anything.get();
      } else {
        return false;
      }
    }
  }, {
    key: 'inspect',
    value: function inspect() {
      if (this.isEmpty) {
        return 'none';
      } else {
        var val = this.get();
        if (val instanceof _None || val instanceof _Some) {
          return 'some(' + val.inspect() + ')';
        } else {
          return 'some(' + (JSON.stringify(val) || '') + ')';
        }
      }
    }
  }]);

  return AbstractOption;
}();

var _None = function (_AbstractOption) {
  _inherits(_None, _AbstractOption);

  function _None() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, _None);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = _None.__proto__ || Object.getPrototypeOf(_None)).call.apply(_ref, [this].concat(args))), _this), _this.isEmpty = true, _this.nonEmpty = false, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(_None, [{
    key: 'get',
    value: function get() {
      throw new Error('Called None.get');
    }
  }]);

  return _None;
}(AbstractOption);

var _Some = function (_AbstractOption2) {
  _inherits(_Some, _AbstractOption2);

  function _Some(value) {
    _classCallCheck(this, _Some);

    var _this2 = _possibleConstructorReturn(this, (_Some.__proto__ || Object.getPrototypeOf(_Some)).call(this));

    _this2.isEmpty = false;
    _this2.nonEmpty = true;

    _this2.value = value;
    return _this2;
  }

  _createClass(_Some, [{
    key: 'get',
    value: function get() {
      return this.value;
    }
  }]);

  return _Some;
}(AbstractOption);

var some = exports.some = function some(a) {
  return new _Some(a);
};
var none = exports.none = new _None();

var of = exports.of = function of(a) {
  if (a === null || a === undefined) {
    return none;
  } else {
    return some(a);
  }
};

exports.default = {
  some: some,
  none: none,
  of: of
};